# Copyright 2001, Hewlett-Packard Corporation
#  $Id: Patches.pm,v 1.14 2001/10/05 01:27:38 tyler_e Exp $


package Bastille::Patches;

use Bastille::API;

@ENV="";
$ENV{PATH}="";
$ENV{CDPATH}=".";
$ENV{BASH_ENV}="";

delete $ENV{BASH_ENV};


#######################################################################
##                          Patches Module                            #
#######################################################################
#
# The purpose of this module is to Install Security Patch Check and/or
# configure it.

&InstallSPC;
&SpcRun;
&CronSPC;

sub InstallSPC {
    if (&getGlobalConfig("Patches","spc_install") eq "Y") {
	my $spc_install_text = "Install Security Patch Check.  You can get it at:\n" . 
	    "http://www.software.hp.com/cgi-bin/swdepot_parser.cgi/cgi/displayProductInfo.pl?productNumber=B6834AA";
	&B_TODO($spc_install_text);
 }
}

# To successfully run SPC in the cron and at Bastille run-time, the root user must accept the disclaimer
# We will add the disclaimer on Bastille backend

sub SpcRun {
    if ((&getGlobalConfig("Patches","spc_run") eq "Y") ||
       (&getGlobalConfig("Patches","spc_norun") eq "Y")) {
	my $proxy = &getGlobalConfig("Patches","spc_proxy");
	if ($proxy ne "") {           # set proxy variable to the user's answer if one exists
	    $proxy = "export ftp_proxy=" . $proxy . "; ";
	}
	&B_TODO("Please read the patch information below and " .
                "install patches as appropriate:\n");
        my $spc = &getGlobal('FILE','spc');
	my $pathexport = "export PATH=/usr/bin:/sbin;";
	my $catalogdir = &getGlobal('BDIR',"home");
	&B_TODO(`$pathexport $proxy $spc -r -q -d -c $catalogdir/security_catalog 2>&1` . "\n\n");
    }
}

sub CronSPC {
    if ((&getGlobalConfig("Patches","spc_cron_run") eq "Y") || 
	(&getGlobalConfig("Patches","spc_cron_norun") eq "Y")) {
	my $proxy = &getGlobalConfig("Patches","spc_proxy");
	my $pathexport = "export PATH=/usr/bin:/sbin;";
	my $catalogdir = &getGlobal('BDIR',"home");
	if ($proxy ne "") {      # set proxy variable to the user's answer if one exists
	    $proxy = "export ftp_proxy=" . $proxy . "; ";
	}
      
	srand; # seed the random number generator (should this use system time?)
               # this is to prevent everyone from trying to access the ftp server
	       # at the same time.
	my $minute = int(rand(60));

	# set up the cron file for root
	unless ( -e &getGlobal('FILE', "root_cron") ) {
	    &B_create_file(&getGlobal('FILE', "root_cron"));
	}
	# adding spc line to the cron file.
	# crontab so that cron rereads its configs for undo.
	&B_System(&getGlobal('BIN','crontab') . " " .&getGlobal('FILE','root_cron'), 
		  &getGlobal('BIN','crontab') . " " .&getGlobal('FILE','root_cron'));
	
	&B_append_line(&getGlobal('FILE', "root_cron"),&getGlobal('FILE','spc') ,
         "$minute " . &getGlobalConfig("Patches", 'spc_cron_time') . " * * * ($pathexport $proxy " . 
		       &getGlobal('FILE','spc'). " -r -q -d -c $catalogdir/security_catalog )\n");

	# crontabing file for cron so that it rereads its configs.
	&B_System(&getGlobal('BIN','crontab') . " " .&getGlobal('FILE','root_cron'), 
		  &getGlobal('BIN','crontab') . " " .&getGlobal('FILE','root_cron'));
	
	&B_System(&getGlobal('FILE','sysconfig_cron') . " stop", &getGlobal('FILE','sysconfig_cron') . " start");
	&B_System(&getGlobal('FILE','sysconfig_cron') . " start", &getGlobal('FILE','sysconfig_cron') . " stop");
	
    }
}

1;











